function OVoteT()
	if(OElgohVote:IsShown()) then 
		OElgohVote:Hide();
		frmOfficer:SetHeight(frmOfficer:GetHeight()-OElgohVote:GetHeight())
	else
		OElgohVote:Show();
		OElgohVote:SetWidth(frmOfficer:GetWidth());
		frmOfficer:SetHeight(frmOfficer:GetHeight()+OElgohVote:GetHeight())
		if(PollTitle==nil) then
			ELGOH:New();
		end
	end
end

function ELGOH:New()
	PollItems = {};
	PollVotes = {};
	PollVoting = false;
	PollTexts={};
	PollTitle="Officer Vote:";
	edtPollTitle:SetText("Which is better?");
end

function ELGOH:SetItem(itemName, index)
	if (index ~= nil) then
		index = math.floor(index)
		PollItems[index] = itemName
	end

	ELGOH:OrderItems();
	ELGOH:List();
	return true
end

function ELGOH:RemoveItem(self, button)
	for index=1,#PollItems do
		if (PollItems[index] == self:GetText()) then
			frmOfficer:SetHeight(frmOfficer:GetHeight()-30);
			OElgohVote:SetHeight(OElgohVote:GetHeight()-30);
			table.remove(PollItems, index);
			self:Hide();
			ELGOH:OrderItems();
			return true;
		end
	end
end

function ELGOH:AddItem(item)
	if(#PollItems==5) then 
		print("Elgoh: Only 5 items may be added");
		edtItem:ClearFocus();
		return false; 
	end
	if(not item) then return false; end
	if(item=="") then return false; end
	for index=0,#PollItems do
		if (PollItems[index] == item) then
			print("Elgoh: Item already exist at "..index);
			edtItem:ClearFocus();
			return false;
		end
	end
	
	frmOfficer:SetHeight(frmOfficer:GetHeight()+30);
	OElgohVote:SetHeight(OElgohVote:GetHeight()+30);
	edtItem:SetText("");
	table.insert(PollItems, index)
		PollItems[#PollItems+1]=item;
	ELGOH:OrderItems()
	return true
end

function ELGOH:List(listing)
	local index, itemName
	if(listing==1) then
		PostTo("Elgoh: Current items in the vote:");
	end
	for index, itemName in pairs(PollItems) do
		PostTo(index..": "..itemName)
	end
	PostTo("use /vote <number> to vote or whisper me with \"!vote <number>\"");
end

function ELGOH:Vote(player, index)
	local indexValid, alreadyVoted

	indexValid = (index ~= nil) and (PollItems[index] ~= nil)
	
	if (not indexValid) then
		return false
	end
	if who==nil then who=UnitName("player"); end
	if(PollVotes[player]==nil) then
		SendChatMessage("Thank you for voting for \""..PollItems[index].."\"!", "WHISPER",GetDefaultLanguage("player"), who);
	else
		SendChatMessage("You've changed your vote to \""..PollItems[index].."\"", "WHISPER",GetDefaultLanguage("player"), who);
	end
	PollVotes[player] = {}
	PollVotes[player]["item"] = index

	local numVotes = 0
	for _, _ in pairs(PollVotes) do
		numVotes = numVotes + 1
	end

	return true
end

function ELGOH:Start()
	if (PollVoting == true) then
		print("Elgoh: Another vote is already in progress");
		return false
	end
	
	if (#PollItems < 2) then
		print("Elgoh: You need to add at least 2 items");
		return false
	end
	Hosting=true;
	PollVoteDuration = 15;
	PollVotes = {};
	OElgohVote.TimeSinceLastUpdate = 0;
	PollVoting = true;
	PostTo(edtPollTitle:GetText());
	ELGOH:List(0);
	btnElgohStart:SetText("Stop");
	SendAddonMessage("elgoh", "new", "GUILD");
end

function ELGOH:Stop()
	PollVoting = false
	Hosting=false
	
	local stuffToSay = {}
	local results = ELGOH:GetResults()

	if (#results == 0) then
		return
	end
	local row

	PostTo("The results are in!")
	PostTo(edtPollTitle:GetText());
	for _, row in pairs(results) do
		PostTo(row)
	end
	
	OElgohVote:SetHeight(120);
	frmOfficer:SetHeight(300);
	
	for index, itemName in pairs(PollItems) do
		if(PollTexts[index]~=nil) then
			PollTexts[index]:Hide();
		end
	end
	SendAddonMessage("elgoh", "finished", "GUILD");
	btnElgohStart:SetText("Start");
	ELGOH:New();
	ELGOH:OrderItems();
end

function ELGOH:GetResults()
	local itemsCount = {}
	local player, playerRow, index
	local totalCount = 0

	if (#PollItems == 0) then
		return {}
	end

	for index, _ in pairs(PollItems) do
		itemsCount[index] = {}
		itemsCount[index]['num']  = 0
		itemsCount[index]['item'] = index
	end

	for player, playerRow in pairs(PollVotes) do
		itemsCount[playerRow['item']]['num'] = itemsCount[playerRow['item']]['num'] + 1
		totalCount = totalCount + 1
	end

	table.sort(itemsCount, CompareResults)

	local resultsTable = {}
	local value
	local position = 1

	if (totalCount == 0) then
		totalCount = 1
	end

	for index, value in pairs(itemsCount) do
		table.insert(resultsTable, position..". "..
			                         PollItems[value['item']]..": ".. value['num'].." ("..math.floor(0.5 + 100 * value['num'] / totalCount).."%)")
		position = position + 1
	end

	return resultsTable
end

function CompareResults(rowA, rowB)
	return rowA['num'] > rowB['num']
end

function ELGOH:OrderItems()
	local index, itemName
	local indexes, newItemList
	newItemList = {}
	indexes = {}
	
	for index, _ in pairs(PollItems) do
		table.insert(indexes, index)
	end
	
	table.sort(indexes)
	
	for _, index in pairs(indexes) do
		newItemList[index] = PollItems[index]
	end

	PollItems = newItemList
	
	for index, itemName in pairs(PollItems) do
		if(PollTexts[index]==nil) then
			PollTexts[index]=CreateFrame("Button",nil,OElgohVote,"UIPanelButtonTemplate")
			PollTexts[index]:RegisterForClicks("AnyUp");
			PollTexts[index]:SetScript("OnClick", RemoveItem);
			PollTexts[index]:SetPoint("TOP", "OElgohVote", "TOP", 0, -(55+(index*25)));
			PollTexts[index]:SetWidth(150)
			PollTexts[index]:SetHeight(20)
			PollTexts[index]:Hide();
		else
			PollTexts[index]:Hide();
		end
		if(PollItems[index]) then
			PollTexts[index]:SetText(PollItems[index]);
			PollTexts[index]:Show();
		else
			PollTexts[index]:Hide();
		end
	end
end

function ELGOH:PollVote(event, ...)
	if (event=="CHAT_MSG_ADDON") then
		local prefix, msg, how, who = ...;
		if(prefix=="elgoh") then
			if(msg=="new" and PollVoting==0) then
				PollVoting=true;
				btnElgohStart:Disable();
			elseif(msg=="finished") then
				btnElgohStart:Enable();
			elseif(msg=="1" or msg=="2" or msg=="3" or msg=="4" or msg=="5" and Hosting==true) then
				msg=tonumber(msg);
				ELGOH:Vote(who, msg);
			end
		end
	elseif (event == "CHAT_MSG_WHISPER") then
		msg,who=...;
		voting = string.find(msg, "!vote")
		if (voting ~= nil) then
			if(PollVoting==true) then
				voting=string.sub(msg, voting+6)
				voting=tonumber(voting);
				ELGOH:Vote(who,voting);
				return
			end
		end
	end
end


function OElgohVote_OnUpdate(this, timer)
	if ((not PollVoting) or (PollVoteDuration == 0)) then return end
	
	OElgohVote.TimeSinceLastUpdate = OElgohVote.TimeSinceLastUpdate + timer
	if( OElgohVote.TimeSinceLastUpdate > PollVoteDuration ) then
		Elgoh:Stop()
	end
end